﻿using System;
using FindSmallest;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace FindSmallestTests
{
    [TestClass]
    public class ProgramTests
    {
        [TestMethod]
        public void FindSmallestTest()
        {
            int[] data = { 3, 2, 4, 5 };
            Assert.AreEqual(2, Program.FindSmallest(data));
            int[] dataOne = { 4 };
            Assert.AreEqual(4, Program.FindSmallest(dataOne));

            int[] dataEmpty = new int[0];
            try
            {
                Program.FindSmallest(dataEmpty);
                Assert.Fail();
            }
            catch (ArgumentException ex)
            {
                Assert.AreEqual("There must be at least one element in the array", ex.Message);
            }
        }

        [TestMethod]
        public void HighestTest()
        {
            Assert.IsTrue(Program.Highest(4, 3) > 0);
        }

        [TestMethod]
        public void LowestTest()
        {
            Assert.IsTrue(Program.Lowest(4, 3) < 0);
        }

        [TestMethod]
        public void TestFindElement()
        {
            int[] data = { 3, 2, 4, 5 };
            Assert.AreEqual(2, Program.FindElement(data, Program.Lowest));
            Assert.AreEqual(5, Program.FindElement(data, Program.Highest));
            int[] dataOne = { 4 };
            Assert.AreEqual(4, Program.FindElement(dataOne, Program.Lowest));
            Assert.AreEqual(4, Program.FindElement(dataOne, Program.Highest));

            int[] dataEmpty = new int[0];
            try
            {
                Program.FindElement(dataEmpty, Program.Lowest);
                Assert.Fail();
            }
            catch (ArgumentException ex)
            {
                Assert.AreEqual("There must be at least one element in the array", ex.Message);
            }
            try
            {
                Program.FindElement(dataEmpty, Program.Highest);
                Assert.Fail();
            }
            catch (ArgumentException ex)
            {
                Assert.AreEqual("There must be at least one element in the array", ex.Message);
            }
        }
    }
}